library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity data_enc is 
        port (
              -- inputs:
                clk : IN STD_LOGIC;
                cdr_in : IN STD_LOGIC;
                ir_in : IN std_logic_vector(1 downto 0);
                vj_add : IN std_logic_vector(3 downto 0);
				ave_v, ave_a, ave_w, max_v, max_a, max_w, min_v, min_a, min_w : in std_logic_vector(15 downto 0);
				temp_data_r : in std_logic_vector(15 downto 0);
				temp_data_l : in std_logic_vector(15 downto 0);
				volt_data : in std_logic_vector(15 downto 0);
				reg : in std_logic_vector(15 downto 0);

              -- outputs:
                 signal disp_out : OUT STD_LOGIC
              );
end entity data_enc;


architecture europa of data_enc is
	signal count : integer range 0 to 16;
	signal dip_out_int : std_logic;
	signal disp_in : std_logic_vector(15 downto 0);
begin

	process(clk)begin
		if(clk'event and clk = '1')then
			if(cdr_in = '1' and ir_in = "01")then
				count <= 0;
			else
				if(count = 16)then
					count <= 16;
				else
					count <= count + 1;
				end if;
			end if;
		end if;
	end process;

	process(count, disp_in)begin
		case count is
			when 0 => disp_out <= disp_in(0);
			when 1 => disp_out <= disp_in(1);
			when 2 => disp_out <= disp_in(2);
			when 3 => disp_out <= disp_in(3);
			when 4 => disp_out <= disp_in(4);
			when 5 => disp_out <= disp_in(5);
			when 6 => disp_out <= disp_in(6);
			when 7 => disp_out <= disp_in(7);
			when 8 => disp_out <= disp_in(8);
			when 9 => disp_out <= disp_in(9);
			when 10 => disp_out <= disp_in(10);
			when 11 => disp_out <= disp_in(11);
			when 12 => disp_out <= disp_in(12);
			when 13 => disp_out <= disp_in(13);
			when 14 => disp_out <= disp_in(14);
			when 15 => disp_out <= disp_in(15);
			when others => disp_out <= '0';
		end case;
	end process;

	process(clk)begin
		if(clk'event and clk = '1')then
			case vj_add is
				when "0000" => disp_in <= ave_v;
				when "0001" => disp_in <= ave_a;
				when "0010" => disp_in <= ave_w;
				when "0011" => disp_in <= max_v;
				when "0100" => disp_in <= max_a;
				when "0101" => disp_in <= max_w;
				when "0110" => disp_in <= min_v;
				when "0111" => disp_in <= min_a;
				when "1000" => disp_in <= min_w;
--				when "1001" => disp_in <= ;
				when "1010" => disp_in <= volt_data;
				when "1011" => disp_in <= temp_data_r;
				when "1100" => disp_in <= temp_data_l;
				when "1101" => disp_in <= reg;
				when "1111" => disp_in <= x"9F50"; -- unique ID for A2GX PCIe board
				when others => null;
			end case;
		end if;
	end process;

end europa;

