library ieee;
use ieee.std_logic_1164.all;

entity max_test is
	port 
	(
		max2_clk : in std_logic;
		max2_wen : in std_logic;
		max2_csn : in std_logic;
		address : in std_logic_vector(4 downto 0);
		data : in std_logic_vector(15 downto 0);
		
		pls_out1 : out std_logic;
		pls_out2 : out std_logic;
		out_data : out std_logic_vector(20 downto 0)
	);
end max_test;


architecture rtl of max_test is
	signal pls_int1 : std_logic := '0';
	signal pls_int2 : std_logic := '0';
begin
	
	process(max2_clk)begin
		if(max2_clk'event and max2_clk = '1')then
			if(max2_wen = '0' and max2_csn = '0')then
				out_data <= address & data;
			end if;
		end if;
	end process;	


	process(max2_clk)begin
		if(rising_edge(max2_clk))then
			if(max2_wen = '0')then
				pls_int1 <= not pls_int1;
			end if;
		end if;
	end process;

	process(max2_clk)begin
		if(rising_edge(max2_clk))then
			if(max2_csn = '0')then
				pls_int2 <= not pls_int2;
			end if;
		end if;
	end process;
	
	pls_out1 <= pls_int1;
	pls_out2 <= pls_int2;
	
end rtl;