library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity mul_48x24 is

	port
	(
	-- inputs
		reset : in std_logic;
		clk : in std_logic;
		data_in1: in std_logic_vector(47 downto 0);
		data_in2: in std_logic_vector(23 downto 0);

	-- outputs
		data_out: out std_logic_vector(71 downto 0)
	);

end mul_48x24;


architecture rtl of mul_48x24 is
	signal counter : integer range 0 to 24;
	signal acm : std_logic_vector(71 downto 0);
	signal shif : std_logic_vector(71 downto 0);
begin

	process(clk)begin
		if(clk'event and clk = '1')then
			if(reset = '0')then
				counter <= 0;
			elsif(counter = 24)then
				counter <= 24;
				data_out <= acm;
			else
				counter <= counter + 1;
			end if;
		end if;
	end process;

	process(clk)begin
		if(clk'event and clk = '1')then
			if(reset = '0')then
				acm <= (others => '0');
			elsif(counter < 24)then
				if(data_in2(counter) /= '0')then
					acm <= acm + shif;
				end if;
			end if;
		end if;
	end process;

	process(clk)begin
		if(clk'event and clk = '1')then
			if(reset = '0')then
				shif(47 downto 0) <= data_in1(47 downto 0);
				shif(71 downto 48) <= (others => '0');
			elsif(counter /= 24)then
				shif(71 downto 1) <= shif(70 downto 0);
				shif(counter) <= '0';
			end if;
		end if;
	end process;

end rtl;